// @formatter:off
define([
  "dojo/_base/declare",
  "dojo/_base/lang",
  "dojo/on",
  "dojo/text!./ExplanationInsight.html",
  "dijit/_TemplatedMixin",
  "dijit/_WidgetsInTemplateMixin",
  "blueconic/api/widgets/insights/_BaseInsight",
  "./Settings",
  "blueconic/api/plugins/css!./ExplanationInsight.css"

// @formatter:on
], function(declare, lang, on, template, _TemplatedMixin, _WidgetsInTemplateMixin, _BaseInsight, Settings, css) {

  // Second argument: array of superclasses
  return declare("insight_explanation.widgets.ExplanationInsight", [_BaseInsight, _TemplatedMixin, _WidgetsInTemplateMixin], {
    templateString: template,

    postCreate: function() {
      // Call the super.
      this.inherited(arguments);

      // Make sure the explanation HTML is updated, when it is changed in the settings
      on(this.parameters, "change", lang.hitch(this, this._updateView));

      // Initial load of the explanation
      this._updateView();

      // Make sure the loader is hidden
      this.hideLoader();
    },

    _updateView: function() {
      var explanation = this.parameters.getValue("explanation");
      this._explanationNode.innerHTML = explanation;
    },

    getSettingsWidget: function() {
      // SettingsWidget' property from the _BaseInsightWidget.
      if (!this._settingsWidget) {
        this._settingsWidget = new Settings({
          parameters: this.parameters
        });
      }
      return this._settingsWidget;
    }

  });

});